; punkoe
; barre.asm - gestion de la barre de saut et de l'entree clavier

  section ".text"

  xdef GestionBarreSaut
  xdef PatchLectureTouches
  xdef Patch2LectureTouches

  include "punkoe.h"

; GestionBarreSaut
; Gestion de l'etat de la barre de saut en fonction de l'entree clavier
GestionBarreSaut:
; Lecture du clavier
  move.b  #%1111110,$600019
  moveq.l #5-1,d0
  \tmp:
  dbf     d0,\tmp
  move.b  $60001B,d0

  lea.l   etatbarre(a4),a0
  tst.w   (a0)
  bne.s   EtatREMPLISSAGE

; Etat VIDE
; Lecture du clavier, passage vers REMPLISSAGE si appui sur [2nd]
PatchLectureTouches:
  btst.l  #4,d0
  bne.s   FinGestionEtatBarreSaut
  ; touche [2nd] appuyee, changement vers REMPLISSAGE
  addq.w  #1,(a0) ; etat barre = remplissage
  clr.w   c_barre(a3)

EtatREMPLISSAGE:
; Etat REMPLISSAGE
; Changement vers VIDE si relchement de la touche [2nd]
Patch2LectureTouches:
  btst.l  #4,d0
  bne.s   \ChangementVersVide

  cmpi.w  #i_barre,c_barre(a3)
  bcs.s   FinGestionEtatBarreSaut
    subq.w  #i_barre,c_barre(a3)

    cmpi.w  #32,d4
    bhs.s   \ChangementVersVideSansSAUT
      addq.w  #1,d4 ; augmentation de la jauge
      rts

\ChangementVersVide:
; Dclenchement de l'vnement SAUT si etatperso = COURT
  tst.w   etatperso(a4)
  bne.s   \ChangementVersVideSansSAUT
  ; Dclenchement de l'vnement SAUT
    addq.w  #1,even_saut(a4)
    moveq.l #64,d0
    sub.w   d4,d0
    sub.w   d4,d0
    move.w  d0,t_vperso(a4) ; valeur du saut
\ChangementVersVideSansSAUT:
  subq.w #1,(a0) ; tat barre = vide
  moveq.l #0,d4 ; remise  0 du remplissage de la barre

FinGestionEtatBarreSaut:
  rts
